## spirv-llvm-translator-17 17.0.17

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4)

if(NOT DEFINED BASE_LLVM_VERSION)
  set (BASE_LLVM_VERSION 17.0.0)
endif(NOT DEFINED BASE_LLVM_VERSION)
set(LLVM_SPIRV_VERSION ${BASE_LLVM_VERSION}.0)

include(FetchContent)
include(FindPkgConfig)

option(LLVM_SPIRV_INCLUDE_TESTS
  "Generate build targets for the llvm-spirv lit tests."
  ${LLVM_INCLUDE_TESTS})

if (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)
  # check if we build inside llvm or not
  if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(LLVM_SPIRV_BUILD_EXTERNAL YES)
  endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
endif (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)

if(LLVM_SPIRV_BUILD_EXTERNAL)
  # Make sure llvm-spirv gets built when building outside the llvm tree.
  set(LLVM_BUILD_TOOLS ON)
endif(LLVM_SPIRV_BUILD_EXTERNAL)

# Download spirv.hpp from the official SPIRV-Headers repository.
# One can skip this step by manually setting
# LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR path.
if(NOT DEFINED LLVM_TOOL_SPIRV_HEADERS_BUILD AND
   NOT DEFINED LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR)
  set(LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
    "${CMAKE_CURRENT_BINARY_DIR}/SPIRV-Headers")
  message(STATUS "SPIR-V Headers location is not specified. Will try to download
          spirv.hpp from https://github.com/KhronosGroup/SPIRV-Headers into
          ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}")
  file(READ spirv-headers-tag.conf SPIRV_HEADERS_TAG)
  # Strip the potential trailing newline from tag
  string(STRIP "${SPIRV_HEADERS_TAG}" SPIRV_HEADERS_TAG)
  FetchContent_Declare(spirv-headers
    GIT_REPOSITORY    https://github.com/KhronosGroup/SPIRV-Headers.git
    GIT_TAG           ${SPIRV_HEADERS_TAG}
    SOURCE_DIR ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}
  )
  FetchContent_MakeAvailable(spirv-headers)
else()
  if(NOT DEFINED LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR)
    # This means LLVM_TOOL_SPIRV_HEADERS_BUILD is defined, therefore
    # SPIRV-Headers exist as a subproject.
    set(LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
      "${CMAKE_SOURCE_DIR}/projects/SPIRV-Headers")
    if(NOT EXISTS ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR})
      message(FATAL_ERROR "No location specified for SPIRV-Headers.
              Try setting the LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
              path or put the project into the llvm/projects folder
              under the name 'SPIRV-Headers'")
    endif()
  endif()
  message(STATUS "Using SPIR-V Headers from
          ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}")
endif()

if(LLVM_SPIRV_BUILD_EXTERNAL)
  project(LLVM_SPIRV
    VERSION
      ${LLVM_SPIRV_VERSION}
    LANGUAGES
      CXX
      C
  )

  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)

  if(LLVM_SPIRV_INCLUDE_TESTS)
    set(LLVM_TEST_COMPONENTS
      llvm-as
      llvm-dis
    )
  endif(LLVM_SPIRV_INCLUDE_TESTS)

  find_package(LLVM ${BASE_LLVM_VERSION} REQUIRED
    COMPONENTS
      Analysis
      BitReader
      BitWriter
      CodeGen
      Core
      Passes
      Support
      TargetParser
      TransformUtils
      ${LLVM_TEST_COMPONENTS}
  )
  set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${LLVM_CMAKE_DIR}
  )
  include(AddLLVM)
  include(HandleLLVMOptions)

  message(STATUS "Found LLVM: ${LLVM_VERSION}")

  option(CCACHE_ALLOWED "allow use of ccache" TRUE)
  find_program(CCACHE_EXE_FOUND ccache)
  if(CCACHE_EXE_FOUND AND CCACHE_ALLOWED)
    message(STATUS "Found ccache: ${CCACHE_EXE_FOUND}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
  endif()
endif()

set(LLVM_SPIRV_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include)

# first try locating SPIRV-Tools via pkgconfig (the old way)
pkg_search_module(SPIRV_TOOLS SPIRV-Tools)
if (NOT SPIRV_TOOLS_FOUND)
  # then try locating SPIRV-Tools via cmake (the new way)
  find_package(SPIRV-Tools)
  find_package(SPIRV-Tools-tools)
  if (SPIRV-Tools_FOUND AND SPIRV-Tools-tools_FOUND)
    set(SPIRV_TOOLS_FOUND TRUE)
    # check for the existance of library targets in the found packages
    if(TARGET SPIRV-Tools-shared)
      # use the shared libary target if present
      set(SPIRV-Tools-library SPIRV-Tools-shared)
    elseif(TARGET SPIRV-Tools-static)
      # otherwise fallback to the static library target
      set(SPIRV-Tools-library SPIRV-Tools-static)
    else()
      message(FATAL_ERROR "Found SPIRV-Tools package but neither "
              "SPIRV-Tools-shared or SPIRV-Tools-static targets exist.")
    endif()
    set(SPIRV_TOOLS_LDFLAGS ${SPIRV-Tools-library})
    get_target_property(SPIRV_TOOLS_INCLUDE_DIRS ${SPIRV-Tools-library} INTERFACE_INCLUDE_DIRECTORIES)
  endif()
endif()

if (NOT SPIRV_TOOLS_FOUND)
  message(STATUS "SPIRV-Tools not found; project will be built without "
          "--spirv-tools-dis support.")
endif()


add_subdirectory(lib/SPIRV)
add_subdirectory(tools/llvm-spirv)
if(LLVM_SPIRV_INCLUDE_TESTS)
  add_subdirectory(test)
endif(LLVM_SPIRV_INCLUDE_TESTS)

install(
  FILES
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVLib.h
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVOpts.h
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVExtensions.inc
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/include/LLVMSPIRVLib
)

configure_file(LLVMSPIRVLib.pc.in ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc @ONLY)
install(
  FILES
    ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/lib${LLVM_LIBDIR_SUFFIX}/pkgconfig
)

=== test/CMakeLists.txt ===
llvm_canonicalize_cmake_booleans(SPIRV_SKIP_CLANG_BUILD)
llvm_canonicalize_cmake_booleans(SPIRV_SKIP_DEBUG_INFO_TESTS)

# required by lit.site.cfg.py.in
get_target_property(LLVM_SPIRV_DIR llvm-spirv BINARY_DIR)
get_target_property(LLVM_SPIRV_LIB_DIR LLVMSPIRVLib BINARY_DIR)
set(LLVM_SPIRV_TEST_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

if(SPIRV_TOOLS_FOUND AND NOT SPIRV-Tools-tools_FOUND)
  # we found SPIRV-Tools via pkgconfig
  find_program(SPIRV_TOOLS_SPIRV_AS NAMES spirv-as PATHS ${SPIRV_TOOLS_PREFIX}/bin)
  if(SPIRV_TOOLS_SPIRV_AS)
    set(SPIRV_TOOLS_SPIRV_AS_FOUND True)
  endif()

  find_program(SPIRV_TOOLS_SPIRV_LINK NAMES spirv-link PATHS ${SPIRV_TOOLS_PREFIX}/bin)
  if(SPIRV_TOOLS_SPIRV_LINK)
    set(SPIRV_TOOLS_SPIRV_LINK_FOUND True)
  endif()

  find_program(SPIRV_TOOLS_SPIRV_VAL NAMES spirv-val PATHS ${SPIRV_TOOLS_PREFIX}/bin)
  if(SPIRV_TOOLS_SPIRV_VAL)
    set(SPIRV_TOOLS_SPIRV_VAL_FOUND True)
  endif()

  set(SPIRV_TOOLS_BINDIR "${SPIRV_TOOLS_PREFIX}/bin")
elseif(SPIRV-Tools-tools_FOUND)
  # we found SPIRV-Tools via cmake targets

  if(TARGET spirv-as)
    set(SPIRV_TOOLS_SPIRV_AS_FOUND True)
  endif()

  if(TARGET spirv-link)
    set(SPIRV_TOOLS_SPIRV_LINK_FOUND True)
  endif()

  if(TARGET spirv-val)
    set(SPIRV_TOOLS_SPIRV_VAL_FOUND True)
  endif()

  get_target_property(SPIRV_AS_PATH spirv-as IMPORTED_LOCATION_RELEASE)
  if(NOT SPIRV_AS_PATH)
    get_target_property(SPIRV_AS_PATH spirv-as IMPORTED_LOCATION_DEBUG)
  endif()

  if(SPIRV_AS_PATH)
    cmake_path(GET SPIRV_AS_PATH PARENT_PATH SPIRV_AS_PATH)
  endif()

  set(SPIRV_TOOLS_BINDIR "${SPIRV_AS_PATH}")
endif()

if(NOT SPIRV_TOOLS_SPIRV_AS_FOUND)
  message(WARNING "spirv-as not found! SPIR-V assembly tests will not be run.")
  set(SPIRV_TOOLS_SPIRV_AS_FOUND False)
endif()

if(NOT SPIRV_TOOLS_SPIRV_LINK_FOUND)
  message(WARNING "spirv-link not found! SPIR-V test involving the linker will not be run.")
  set(SPIRV_TOOLS_SPIRV_LINK_FOUND False)
endif()

if(NOT SPIRV_TOOLS_SPIRV_VAL_FOUND)
  message(WARNING "spirv-val not found! SPIR-V generated for test suite will not be validated.")
  set(SPIRV_TOOLS_SPIRV_VAL_FOUND False)
endif()

configure_lit_site_cfg(
  ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.py.in
  ${CMAKE_CURRENT_BINARY_DIR}/lit.site.cfg.py
  MAIN_CONFIG
    ${CMAKE_CURRENT_SOURCE_DIR}/lit.cfg.py
)

if(NOT LLVM_SPIRV_BUILD_EXTERNAL)
  set(LLVM_SPIRV_TEST_DEPS
    FileCheck
    count
    llvm-as
    llvm-config
    llvm-dis
    not
  )
  if(NOT SPIRV_SKIP_CLANG_BUILD)
    list(APPEND LLVM_SPIRV_TEST_DEPS
      clang
    )
  endif(NOT SPIRV_SKIP_CLANG_BUILD)
  if(NOT SPIRV_SKIP_DEBUG_INFO_TESTS)
    list(APPEND LLVM_SPIRV_TEST_DEPS
      llc
      llvm-dwarfdump
      llvm-objdump
      llvm-readelf
      llvm-readobj
    )
  endif(NOT SPIRV_SKIP_DEBUG_INFO_TESTS)
endif(NOT LLVM_SPIRV_BUILD_EXTERNAL)


add_lit_testsuite(check-llvm-spirv "Running the LLVM-SPIRV regression tests"
  ${CMAKE_CURRENT_BINARY_DIR}
  ARGS
    --verbose
  DEPENDS
    ${LLVM_SPIRV_TEST_DEPS}
    llvm-spirv
)

# to enable a custom test target on cmake below 3.11
# starting with 3.11 "test" is only reserved if ENABLE_TESTING(ON)
if(LLVM_SPIRV_BUILD_EXTERNAL)
  cmake_policy(PUSH)
  if(POLICY CMP0037 AND ${CMAKE_VERSION} VERSION_LESS "3.11.0")
    cmake_policy(SET CMP0037 OLD)
  endif(POLICY CMP0037 AND ${CMAKE_VERSION} VERSION_LESS "3.11.0")
  add_custom_target(test
    DEPENDS
      check-llvm-spirv
  )
  cmake_policy(POP)
endif(LLVM_SPIRV_BUILD_EXTERNAL)

=== lib/SPIRV/CMakeLists.txt ===
set(SRC_LIST
  LLVMSPIRVOpts.cpp
  LLVMToSPIRVDbgTran.cpp
  Mangler/FunctionDescriptor.cpp
  Mangler/Mangler.cpp
  Mangler/ManglingUtils.cpp
  Mangler/ParameterType.cpp
  OCLToSPIRV.cpp
  OCLTypeToSPIRV.cpp
  OCLUtil.cpp
  VectorComputeUtil.cpp
  SPIRVBuiltinHelper.cpp
  SPIRVLowerBitCastToNonStandardType.cpp
  SPIRVLowerBool.cpp
  SPIRVLowerConstExpr.cpp
  SPIRVLowerMemmove.cpp
  SPIRVLowerOCLBlocks.cpp
  SPIRVLowerSaddWithOverflow.cpp
  SPIRVReader.cpp
  SPIRVRegularizeLLVM.cpp
  SPIRVToLLVMDbgTran.cpp
  SPIRVToOCL.cpp
  SPIRVToOCL12.cpp
  SPIRVToOCL20.cpp
  SPIRVTypeScavenger.cpp
  SPIRVUtil.cpp
  SPIRVWriter.cpp
  SPIRVWriterPass.cpp
  PreprocessMetadata.cpp
  libSPIRV/SPIRVBasicBlock.cpp
  libSPIRV/SPIRVDebug.cpp
  libSPIRV/SPIRVDecorate.cpp
  libSPIRV/SPIRVEntry.cpp
  libSPIRV/SPIRVFunction.cpp
  libSPIRV/SPIRVInstruction.cpp
  libSPIRV/SPIRVModule.cpp
  libSPIRV/SPIRVStream.cpp
  libSPIRV/SPIRVType.cpp
  libSPIRV/SPIRVValue.cpp
  libSPIRV/SPIRVFnVar.cpp
)
add_llvm_library(LLVMSPIRVLib
  ${SRC_LIST}
  LINK_COMPONENTS
    Analysis
    BitWriter
    CodeGen
    Core
    Demangle
    IRReader
    Linker
    Passes
    Support
    TargetParser
    TransformUtils
  DEPENDS
    intrinsics_gen
  )

target_include_directories(LLVMSPIRVLib
  PRIVATE
    ${LLVM_INCLUDE_DIRS}
    ${LLVM_SPIRV_INCLUDE_DIRS}
    # TODO: Consider using SPIRV-Headers' as a header-only INTERFACE
    # instead. Right now this runs into exporting issues with
    # the LLVM in-tree builds.
    ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/libSPIRV
    ${CMAKE_CURRENT_SOURCE_DIR}/Mangler
)

## spirv-llvm-translator-17 17.0.0

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.0-4deepin1) unstable; urgency=medium

  * chore: Bump gcc Depends to 12.

 -- hudeng <hudeng@deepin.org>  Fri, 21 Jun 2024 11:42:04 +0800

spirv-llvm-translator-17 (17.0.0-4) unstable; urgency=medium

  * Restrict watch file to 17.* releases.
  * Update .symbols control file.
  * Add build-needed autopkgtest for spirv-headers compat check.
  * Update from llvm_release_170 branch.  (Closes: #1063632)
  * Bump spirv-headers dependency to 1.6.1+1.3.275.0.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 10 Feb 2024 10:17:54 +0100

spirv-llvm-translator-17 (17.0.0-3) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Mark some new symbols as optional as they don't appear with LTO.
    (Closes: #1055378)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 07 Nov 2023 09:53:24 +0100

spirv-llvm-translator-17 (17.0.0-2) unstable; urgency=medium

  * Update .symbols control file.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 04 Nov 2023 16:05:21 +0100

spirv-llvm-translator-17 (17.0.0-1) experimental; urgency=medium

  * New upstream release.
  * Bump spirv-headers build-dependency to 1.6.1+1.3.261.
  * Fork source package as spirv-llvm-translator-17.
  * Rename binary packages: *16* => *17*.
  * Build with llvm 17.
  * Update .symbols control file.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 12 Oct 2023 16:29:16 +0200

spirv-llvm-translator-16 (16.0.0-6) unstable; urgency=medium

  * Add build-needed autopkgtest for spirv-headers compat check.
  * Update from llvm_release_160 branch.
  * Bump spirv-headers dependency to 1.6.1+1.3.275.0.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 09 Feb 2024 14:42:13 +0100

spirv-llvm-translator-16 (16.0.0-5) unstable; urgency=medium

  * Restrict watch file to 16.* releases.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 29 Sep 2023 14:21:37 +0200

spirv-llvm-translator-16 (16.0.0-4) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Mark more symbols as optional as they don't appear with LTO.
    (Closes: #1043047)

 -- Andreas Beckmann <anbe@debian.org>  Sat, 05 Aug 2023 12:20:42 +0200

spirv-llvm-translator-16 (16.0.0-3) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Update .symbols control file for gcc-13 builds.  (Closes: #1042192)

  [ Gianfranco Costamagna ]
  * Mark some more symbols as optional as they don't appear on Ubuntu (LTO?).
    (Closes: #1042819)

 -- Andreas Beckmann <anbe@debian.org>  Fri, 04 Aug 2023 12:09:10 +0200

spirv-llvm-translator-16 (16.0.0-2) unstable; urgency=medium

  * Update from llvm_release_160 branch.
  * Upload to unstable.  (Closes: #1037466)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 15 Jun 2023 14:01:00 +0200

spirv-llvm-translator-16 (16.0.0-1) experimental; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Bump spirv-headers build-dependency to 1.6.1+1.3.243.
  * Fork source package as spirv-llvm-translator-16.
  * Rename binary packages: *15* => *16*.
  * Build with llvm 16.
  * Update .symbols control file.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 20 Apr 2023 18:57:02 +0200

spirv-llvm-translator-15 (15.0.0-6) unstable; urgency=medium

  * Add build-needed autopkgtest for spirv-headers compat check.
  * Update from llvm_release_150 branch.
  * Bump spirv-headers dependency to 1.6.1+1.3.275.0.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 08 Feb 2024 22:48:18 +0100

spirv-llvm-translator-15 (15.0.0-5) unstable; urgency=medium

  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 29 Sep 2023 13:48:15 +0200

spirv-llvm-translator-15 (15.0.0-4) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Update .symbols control file for gcc-13 builds.

  [ Gianfranco Costamagna ]
  * Mark some more symbols as optional as they don't appear on Ubuntu (LTO?).
    (Closes: #1042819)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 03 Aug 2023 11:46:40 +0200

spirv-llvm-translator-15 (15.0.0-3) unstable; urgency=medium

  * Fix compatibility with newer spirv-as.  (Closes: #1040056)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 11 Jul 2023 15:05:17 +0200

spirv-llvm-translator-15 (15.0.0-2) unstable; urgency=medium

  * Merge changes from spirv-llvm-translator-14 14.0.0-5.
  * Restrict watch file to 15.* releases.
  * Bump Standards-Version to 4.6.2.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 04 Apr 2023 11:24:20 +0200

spirv-llvm-translator-15 (15.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Fork source package as spirv-llvm-translator-15.
  * Rename binary packages: *14* => *15*.
  * Build with llvm 15.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 03 Oct 2022 02:09:37 +0200

spirv-llvm-translator-14 (14.0.0-10) unstable; urgency=medium

  * Add build-needed autopkgtest for spirv-headers compat check.
  * Update from llvm_release_140 branch.
  * Bump spirv-headers dependency to 1.6.1+1.3.275.0.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 08 Feb 2024 03:47:14 +0100

spirv-llvm-translator-14 (14.0.0-9) unstable; urgency=medium

  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 29 Sep 2023 13:39:11 +0200

spirv-llvm-translator-14 (14.0.0-8) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Mark some more symbols as optional as they don't appear on Ubuntu (LTO?).
    (Closes: #1042819)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 01 Aug 2023 14:45:06 +0200

spirv-llvm-translator-14 (14.0.0-7) unstable; urgency=medium

  * Update .symbols control file for gcc-13 builds.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 31 Jul 2023 11:05:53 +0200

spirv-llvm-translator-14 (14.0.0-6) unstable; urgency=medium

  * Fix compatibility with newer spirv-as.  (Closes: #1040055)
  * Bump Standards-Version to 4.6.2.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 11 Jul 2023 14:03:54 +0200

spirv-llvm-translator-14 (14.0.0-5) unstable; urgency=medium



=== debian/control ===
Source: spirv-llvm-translator-17
Section: libdevel
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Timo Aaltonen <tjaalton@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends: debhelper-compat (= 13),
 dh-sequence-pkgkde-symbolshelper,
 cmake,
 gcc (>= 12),
 pkgconf,
 spirv-headers (>= 1.6.1+1.3.275.0),
 spirv-tools,
# keep the clang/llvm version in sync, don't forget debian/tests/control
 libclang-17-dev,
 llvm-17-dev,
 clang-17 <!nocheck>,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git -b llvm17/main

Package: libllvmspirvlib17
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: bi-directional translator for LLVM/SPIRV -- shared library
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes the shared library.

Package: libllvmspirvlib-17-dev
Architecture: any
Multi-Arch: same
Depends:
 libllvmspirvlib17 (= ${binary:Version}),
 ${misc:Depends}
Conflicts:
 libllvmspirvlib-x.y-dev,
Breaks:
 libllvmspirvlib-dev (<< 13.0.0-3~),
Replaces:
 libllvmspirvlib-dev (<< 13.0.0-3~),
 libllvmspirvlib-x.y-dev,
Provides:
 libllvmspirvlib-x.y-dev,
Description: bi-directional translator for LLVM/SPIRV -- development files
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes static libs and headers for development.

Package: llvm-spirv-17
Architecture: any
Depends:
 libllvmspirvlib17 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: bi-directional translator for LLVM/SPIRV
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes the llvm-spirv-17 binary.

=== debian/tests/control ===
Tests: upstream-testsuite
Architecture: amd64
Depends:
 @,
 cmake,
 g++,
 make,
 pkgconf,
 spirv-headers,
 spirv-tools,
 clang-17,
 llvm-17-dev,
Restrictions:
 allow-stderr,

Test-Command: debian/tests/upstream-testsuite
Features: test-name=upstream-testsuite-flaky
Architecture: !amd64
Depends:
 @,
 cmake,
 g++,
 make,
 pkgconf,
 spirv-headers,
 spirv-tools,
 clang-17,
 llvm-17-dev,
Restrictions:
 allow-stderr,
 flaky,

Test-Command: true
Features: test-name=spirv-headers-compatibility
Depends:
 spirv-headers,
Restrictions:
 build-needed,
 allow-stderr,
 superficial,

## spirv-llvm-translator-17 17.0.1

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.1-1) unstable; urgency=medium

  * New upstream release.  (Closes: #1073402)
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 19 Jun 2024 22:15:40 +0200

spirv-llvm-translator-17 (17.0.0-5) unstable; urgency=medium

  * Skip upstream testsuite on big-endian architectures (> 60% of the tests
    are failing anyway but ignored) due to excessive disk space usage
    (> 40 GB).  (Closes: #1065395)
  * Update from llvm_release_170 branch (v17.0.0-12-ga126a792).

 -- Andreas Beckmann <anbe@debian.org>  Sat, 16 Mar 2024 05:07:59 +0100

spirv-llvm-translator-16 (16.0.1-1) unstable; urgency=medium

  * New upstream release.  (Closes: #1073405)
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 19 Jun 2024 11:54:43 +0200

spirv-llvm-translator-16 (16.0.0-7) unstable; urgency=medium

  * Skip upstream testsuite on big-endian architectures (> 60% of the tests
    are failing anyway but ignored) due to excessive disk space usage
    (> 40 GB).  (Closes: #1065395)
  * Update from llvm_release_160 branch (v16.0.0-37-g9c9b6096).
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 15 Mar 2024 20:14:04 +0100

spirv-llvm-translator-15 (15.0.1-1) unstable; urgency=medium

  * New upstream release.  (Closes: #1073426)
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 18 Jun 2024 14:51:41 +0200

spirv-llvm-translator-15 (15.0.0-7) unstable; urgency=medium

  * Skip upstream testsuite on big-endian architectures (> 60% of the tests
    are failing anyway but ignored) due to excessive disk space usage
    (> 40 GB).  (Closes: #1065395)
  * Update from llvm_release_150 branch (v15.0.0-85-gda050541).
  * Disable two commits causing test failures.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 14 Mar 2024 20:01:08 +0100

spirv-llvm-translator-14 (14.0.1-2) unstable; urgency=medium

  * Update .symbols control file.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 17 Jun 2024 15:41:43 +0200

spirv-llvm-translator-14 (14.0.1-1) experimental; urgency=medium

  * New upstream release.
  * Update .symbols control file.
  * Bump Standards-Version to 4.7.0, no changes needed.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 14 Jun 2024 11:31:37 +0200

spirv-llvm-translator-14 (14.0.0-12) unstable; urgency=medium

  * Update from llvm_release_140 branch (v14.0.0-179-gd54b2cea).
  * Disable the upstream-testsuite autopkgtest on s390x.  (Closes: #1065395)

 -- Andreas Beckmann <anbe@debian.org>  Wed, 06 Mar 2024 12:21:28 +0100

spirv-llvm-translator-14 (14.0.0-11) unstable; urgency=medium

  * Update from llvm_release_140 branch (v14.0.0-177-g0141f3dd).
  * Skip tests on big-endian architectures (> 60% are failing) due to
    excessive disk space usage (>40 GB). The failures are ignored on !amd64
    anyway.  (Closes: #1065395)
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 05 Mar 2024 05:13:45 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Build-Depends: debhelper-compat (= 13),
  dh-sequence-pkgkde-symbolshelper,
  cmake,
- gcc (>= 12),
+ gcc (>= 4:13),
  pkgconf,
  spirv-headers (>= 1.6.1+1.3.275.0),
  spirv-tools,
@@ -17,7 +17,7 @@
  llvm-17-dev,
  clang-17 <!nocheck>,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
 Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git -b llvm17/main

## spirv-llvm-translator-17 17.0.4

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.4-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.4-1.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 12 Sep 2024 21:25:22 +0200

spirv-llvm-translator-16 (16.0.4-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.4-2.
  * Update .symbols control file.
  * Update copyright file.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 11 Sep 2024 10:49:59 +0200

spirv-llvm-translator-15 (15.0.4-2) unstable; urgency=medium

  * Merge changes from spirv-llvm-translator-14 14.0.4-2.
  * Update .symbols control file.
  * Update copyright file.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 Sep 2024 09:43:06 +0200

spirv-llvm-translator-15 (15.0.4-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.4-1.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 07 Sep 2024 20:57:52 +0200

spirv-llvm-translator-15 (15.0.3-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.3-2.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 29 Aug 2024 09:54:22 +0200

spirv-llvm-translator-14 (14.0.4-2) unstable; urgency=medium

  * Update .symbols control file.
  * Update copyright file.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 09 Sep 2024 21:29:45 +0200

spirv-llvm-translator-14 (14.0.4-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 07 Sep 2024 02:55:08 +0200

spirv-llvm-translator-14 (14.0.3-2) unstable; urgency=medium

  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 22 Aug 2024 18:07:54 +0200

spirv-llvm-translator-14 (14.0.3-1) unstable; urgency=medium

  * New upstream release.
  * Update .symbols control file for gcc-14 builds.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 22 Aug 2024 12:08:12 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Build-Depends: debhelper-compat (= 13),
  dh-sequence-pkgkde-symbolshelper,
  cmake,
- gcc (>= 4:13),
+ gcc (>= 4:14),
  pkgconf,
  spirv-headers (>= 1.6.1+1.3.275.0),
  spirv-tools,

## spirv-llvm-translator-17 17.0.7

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.7-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.7-1.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 08 Dec 2024 23:19:46 +0100

spirv-llvm-translator-16 (16.0.7-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.7-1.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 07 Dec 2024 21:41:38 +0100

spirv-llvm-translator-15 (15.0.7-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.7-1.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 07 Dec 2024 20:59:18 +0100

spirv-llvm-translator-14 (14.0.7-1) unstable; urgency=medium

  * New upstream release.
  * Add substvar for the llvm major version.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 07 Dec 2024 00:31:38 +0100

spirv-llvm-translator-14 (14.0.6-1) unstable; urgency=medium

  * New upstream release.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 28 Nov 2024 22:26:06 +0100

=== debian/control ===
--- 
+++ 
@@ -40,7 +40,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libllvmspirvlib17 (= ${binary:Version}),
+ libllvmspirvlib${llvm:major} (= ${binary:Version}),
  ${misc:Depends}
 Conflicts:
  libllvmspirvlib-x.y-dev,
@@ -61,7 +61,7 @@
 Package: llvm-spirv-17
 Architecture: any
 Depends:
- libllvmspirvlib17 (= ${binary:Version}),
+ libllvmspirvlib${llvm:major} (= ${binary:Version}),
  ${shlibs:Depends},
  ${misc:Depends}
 Description: bi-directional translator for LLVM/SPIRV
@@ -69,4 +69,4 @@
  package includes a library and a tool for translation between LLVM IR
  and SPIR-V.
  .
- This package includes the llvm-spirv-17 binary.
+ This package includes the llvm-spirv-${llvm:major} binary.

## spirv-llvm-translator-17 17.0.8

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.8-1~ubuntu0.24.04.1) noble; urgency=medium

  * Backport to noble. (LP: #2111480)
    - relax gcc build-dep
    - don't fail dh_makeshlibs if symbols don't match (fails on 32bit)

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 28 Jul 2025 14:17:34 +0300

spirv-llvm-translator-17 (17.0.8-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.8-1.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 06 Jan 2025 14:37:08 +0100

spirv-llvm-translator-16 (16.0.8-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.8-1.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 05 Jan 2025 22:37:13 +0100

spirv-llvm-translator-15 (15.0.8-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.8-1.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 05 Jan 2025 21:30:35 +0100

spirv-llvm-translator-14 (14.0.8-1) unstable; urgency=medium

  * New upstream release.
  * Add substvar for the llvm soversion.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 05 Jan 2025 18:18:33 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Build-Depends: debhelper-compat (= 13),
  dh-sequence-pkgkde-symbolshelper,
  cmake,
- gcc (>= 4:14),
+ gcc (>= 4:13),
  pkgconf,
  spirv-headers (>= 1.6.1+1.3.275.0),
  spirv-tools,
@@ -40,7 +40,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libllvmspirvlib${llvm:major} (= ${binary:Version}),
+ libllvmspirvlib${llvm:soversion} (= ${binary:Version}),
  ${misc:Depends}
 Conflicts:
  libllvmspirvlib-x.y-dev,
@@ -61,7 +61,7 @@
 Package: llvm-spirv-17
 Architecture: any
 Depends:
- libllvmspirvlib${llvm:major} (= ${binary:Version}),
+ libllvmspirvlib${llvm:soversion} (= ${binary:Version}),
  ${shlibs:Depends},
  ${misc:Depends}
 Description: bi-directional translator for LLVM/SPIRV

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS	 = hardening=+all

include /usr/share/dpkg/pkg-info.mk

LLVM_VERSION	 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-dev.*/\1/p' debian/control)
LLVM_SOVERSION	 = $(LLVM_VERSION)

%:
	dh $@ --builddir build/

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_SKIP_RPATH=ON \
		-DLLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR=/usr/include \
		-DBUILD_SHARED_LIBS=ON \
		-DLLVM_SPIRV_INCLUDE_TESTS=ON \
		-DLLVM_EXTERNAL_LIT=/usr/lib/llvm-$(LLVM_VERSION)/build/utils/lit/lit.py \
		-Wno-dev

execute_after_dh_auto_install:
	mv debian/tmp/usr/bin/llvm-spirv debian/tmp/usr/bin/llvm-spirv-$(LLVM_VERSION)

# skip tests on big-endian architectures, uses excessive amount (> 40GB) of disk space
ignore_test_failures	 = $(if $(filter $(DEB_HOST_ARCH),amd64),,-)
override_dh_auto_test:
ifeq ($(DEB_HOST_ARCH_ENDIAN),little)
	$(ignore_test_failures)env LD_LIBRARY_PATH=$(LD_LIBRARY_PATH):$(CURDIR)/build/lib/SPIRV dh_auto_test
endif

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'llvm:major=$(LLVM_VERSION)' \
		-V'llvm:soversion=$(LLVM_SOVERSION)' \

update-symbols:
	pkgkde-getbuildlogs
	echo "pkgkde-symbolshelper batchpatch -v $(DEB_VERSION_EPOCH_UPSTREAM) $(DEB_SOURCE)_$(DEB_DISTRIBUTION)_logs/$(DEB_SOURCE)_$(DEB_VERSION)_*build"


ifneq (,$(wildcard .git))
upstream:
	git remote show $@ >/dev/null 2>&1 || git remote add $@ $(shell sed -rn 's/Repository: //p' debian/upstream/metadata)
	git fetch $@ --prune
endif

override_dh_makeshlibs:
	dh_makeshlibs -- -c0

=== debian/tests/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 Test-Command: debian/tests/upstream-testsuite
 Features: test-name=upstream-testsuite-flaky
-Architecture: !amd64
+Architecture: !amd64 !s390x
 Depends:
  @,
  cmake,

## spirv-llvm-translator-17 17.0.10

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.10-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.10-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.309.0.
  * Bump Standards-Version to 4.7.2, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 22 Mar 2025 03:26:22 +0100

spirv-llvm-translator-16 (16.0.10-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.10-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.309.0.
  * Bump Standards-Version to 4.7.2, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 21 Mar 2025 13:02:08 +0100

spirv-llvm-translator-15 (15.0.10-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.10-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.309.0.
  * Bump Standards-Version to 4.7.2, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 21 Mar 2025 12:48:04 +0100

spirv-llvm-translator-14 (14.0.10-1) unstable; urgency=medium

  * New upstream release.
  * Bump spirv-headers dependency to 1.6.1+1.4.309.0.
  * Bump Standards-Version to 4.7.2, no changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 19 Mar 2025 09:16:37 +0100

## spirv-llvm-translator-17 17.0.11

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.11-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.11-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 08 Apr 2025 15:33:14 +0200

spirv-llvm-translator-16 (16.0.11-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.11-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 08 Apr 2025 10:07:57 +0200

spirv-llvm-translator-15 (15.0.11-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.11-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 08 Apr 2025 10:00:20 +0200

spirv-llvm-translator-14 (14.0.11-1) unstable; urgency=medium

  * New upstream release.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 07 Apr 2025 17:08:58 +0200

=== debian/control ===
--- 
+++ 
@@ -8,16 +8,16 @@
 Build-Depends: debhelper-compat (= 13),
  dh-sequence-pkgkde-symbolshelper,
  cmake,
- gcc (>= 4:13),
+ gcc (>= 4:14),
  pkgconf,
- spirv-headers (>= 1.6.1+1.3.275.0),
+ spirv-headers (>= 1.6.1+1.4.309.0),
  spirv-tools,
 # keep the clang/llvm version in sync, don't forget debian/tests/control
  libclang-17-dev,
  llvm-17-dev,
  clang-17 <!nocheck>,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
 Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git -b llvm17/main

## spirv-llvm-translator-17 17.0.15

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.15-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.15-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.313.0.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 13 Aug 2025 03:25:13 +0200

spirv-llvm-translator-16 (16.0.15-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.15-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.313.0.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Aug 2025 13:18:32 +0200

spirv-llvm-translator-15 (15.0.15-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.14-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.313.0.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Aug 2025 13:01:04 +0200

spirv-llvm-translator-14 (14.0.14-1) unstable; urgency=medium

  * New upstream release.
  * Bump spirv-headers dependency to 1.6.1+1.4.313.0.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Aug 2025 10:36:48 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  cmake,
  gcc (>= 4:14),
  pkgconf,
- spirv-headers (>= 1.6.1+1.4.309.0),
+ spirv-headers (>= 1.6.1+1.4.313.0),
  spirv-tools,
 # keep the clang/llvm version in sync, don't forget debian/tests/control
  libclang-17-dev,

## spirv-llvm-translator-17 17.0.16

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.16-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.16-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.321.0-2.
  * Update .symbols control file.
  * Build with g++-14.  (Closes: #1097919)

 -- Andreas Beckmann <anbe@debian.org>  Sat, 06 Sep 2025 10:46:57 +0200

spirv-llvm-translator-16 (16.0.16-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.16-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.321.0-2.
  * Update .symbols control file.
  * Build with g++-14.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 04 Sep 2025 11:10:17 +0200

spirv-llvm-translator-15 (15.0.16-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.15-2.
  * Bump spirv-headers dependency to 1.6.1+1.4.321.0-2.
  * Update .symbols control file.
  * Build with g++-14.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 04 Sep 2025 10:43:12 +0200

spirv-llvm-translator-14 (14.0.15-2) unstable; urgency=medium

  * Build with g++-14.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 04 Sep 2025 17:27:18 +0200

spirv-llvm-translator-14 (14.0.15-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 04 Sep 2025 00:33:43 +0200

=== debian/control ===
--- 
+++ 
@@ -9,8 +9,9 @@
  dh-sequence-pkgkde-symbolshelper,
  cmake,
  gcc (>= 4:14),
+ g++-14,
  pkgconf,
- spirv-headers (>= 1.6.1+1.4.313.0),
+ spirv-headers (>= 1.6.1+1.4.321.0-2~),
  spirv-tools,
 # keep the clang/llvm version in sync, don't forget debian/tests/control
  libclang-17-dev,

## spirv-llvm-translator-17 17.0.17

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.17-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.17-1.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Oct 2025 22:49:07 +0200

spirv-llvm-translator-16 (16.0.17-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.17-1.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Oct 2025 20:17:57 +0200

spirv-llvm-translator-15 (15.0.17-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.16-1.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 09 Oct 2025 20:04:01 +0200

spirv-llvm-translator-14 (14.0.16-1) unstable; urgency=medium

  * New upstream release.
  * Drop redundant Rules-Requires-Root: no.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 08 Oct 2025 21:43:03 +0200

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,6 @@
  libclang-17-dev,
  llvm-17-dev,
  clang-17 <!nocheck>,
-Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
 Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator

=== debian/rules ===
--- 
+++ 
@@ -1,16 +1,25 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS	 = hardening=+all
+export CXX=g++-14
 
 include /usr/share/dpkg/pkg-info.mk
 
 LLVM_VERSION	 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-dev.*/\1/p' debian/control)
 LLVM_SOVERSION	 = $(LLVM_VERSION)
 
+AUTOGEN		 = debian/libllvmspirvlib$(LLVM_SOVERSION).install
+AUTOGEN		+= debian/libllvmspirvlib$(LLVM_SOVERSION).symbols
+
 %:
 	dh $@ --builddir build/
 
-override_dh_auto_configure:
+libllvmspirvlib$(LLVM_SOVERSION).%: libllvmspirvlibSOVERSION.%
+	ln -s $(<F) $@
+
+autogen: $(AUTOGEN) ;
+
+override_dh_auto_configure: autogen
 	dh_auto_configure -- \
 		-DCMAKE_SKIP_RPATH=ON \
 		-DLLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR=/usr/include \
@@ -34,7 +43,10 @@
 		-V'llvm:major=$(LLVM_VERSION)' \
 		-V'llvm:soversion=$(LLVM_SOVERSION)' \
 
-update-symbols:
+execute_after_dh_clean:
+	$(RM) $(AUTOGEN)
+
+update-symbols: debian/libllvmspirvlib$(LLVM_SOVERSION).symbols
 	pkgkde-getbuildlogs
 	echo "pkgkde-symbolshelper batchpatch -v $(DEB_VERSION_EPOCH_UPSTREAM) $(DEB_SOURCE)_$(DEB_DISTRIBUTION)_logs/$(DEB_SOURCE)_$(DEB_VERSION)_*build"
 
@@ -44,6 +56,3 @@
 	git remote show $@ >/dev/null 2>&1 || git remote add $@ $(shell sed -rn 's/Repository: //p' debian/upstream/metadata)
 	git fetch $@ --prune
 endif
-
-override_dh_makeshlibs:
-	dh_makeshlibs -- -c0

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%spirv-llvm-translator-$1.tar.gz%" \
   https://github.com/KhronosGroup/SPIRV-LLVM-Translator/tags \
   (?:.*?/)?v?(17\.[\d.]*)\.tar\.gz

## spirv-llvm-translator-17 17.0.18

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.18-2) unstable; urgency=medium

  * Merge changes from spirv-llvm-translator-16 16.0.18-1.
  * Update B-D after the spirv-tools split.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 23 Nov 2025 09:05:26 +0100

spirv-llvm-translator-17 (17.0.18-1) unstable; urgency=medium

  * New upstream release.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 19 Nov 2025 21:54:25 +0100

spirv-llvm-translator-17 (17.0.17-2) unstable; urgency=medium

  * Build with g++-15.
  * Update .symbols control file for GCC 15 builds.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 16 Nov 2025 00:32:56 +0100

spirv-llvm-translator-16 (16.0.18-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.18-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 22 Nov 2025 01:12:42 +0100

spirv-llvm-translator-15 (15.0.18-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.17-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 22 Nov 2025 00:41:35 +0100

spirv-llvm-translator-14 (14.0.17-1) unstable; urgency=medium

  * New upstream release.
  * Update B-D after the spirv-tools split.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 21 Nov 2025 22:05:19 +0100

=== debian/tests/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  pkgconf,
  spirv-headers,
  spirv-tools,
+ spirv-tools-dev,
  clang-17,
  llvm-17-dev,
 Restrictions:
@@ -24,6 +25,7 @@
  pkgconf,
  spirv-headers,
  spirv-tools,
+ spirv-tools-dev,
  clang-17,
  llvm-17-dev,
 Restrictions:

## spirv-llvm-translator-17 17.0.19

=== debian/changelog ===
spirv-llvm-translator-17 (17.0.19-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-16 16.0.19-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 20 Dec 2025 23:20:01 +0100

spirv-llvm-translator-16 (16.0.19-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-15 15.0.19-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 20 Dec 2025 11:52:55 +0100

spirv-llvm-translator-15 (15.0.19-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-14 14.0.18-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 20 Dec 2025 11:44:25 +0100

spirv-llvm-translator-14 (14.0.18-1) unstable; urgency=medium

  * New upstream release.
  * Bump spirv-headers dependency to 1.6.1+1.4.328.0.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 19 Dec 2025 23:00:55 +0100

=== debian/control ===
--- 
+++ 
@@ -8,13 +8,13 @@
 Build-Depends: debhelper-compat (= 13),
  dh-sequence-pkgkde-symbolshelper,
  cmake,
- gcc (>= 4:14),
- g++-14,
+ gcc (>= 4:15),
  pkgconf,
- spirv-headers (>= 1.6.1+1.4.321.0-2~),
- spirv-tools,
+ spirv-headers (>= 1.6.1+1.4.328.0),
+ spirv-tools <!nocheck>,
+ spirv-tools-dev,
 # keep the clang/llvm version in sync, don't forget debian/tests/control
- libclang-17-dev,
+ libclang-17-dev (>= 1:17.0.6-23~),
  llvm-17-dev,
  clang-17 <!nocheck>,
 Standards-Version: 4.7.2

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,6 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS	 = hardening=+all
-export CXX=g++-14
 
 include /usr/share/dpkg/pkg-info.mk
 
@@ -45,6 +44,7 @@
 
 execute_after_dh_clean:
 	$(RM) $(AUTOGEN)
+	$(RM) -r spirv-llvm-translator-??_*_logs
 
 update-symbols: debian/libllvmspirvlib$(LLVM_SOVERSION).symbols
 	pkgkde-getbuildlogs
